import sys
from com.ibm.j2ca.migration.wpsruntime.base import WPSMigrationUtil

wpsRootPath=WPSMigrationUtil.getSystemProperty("was.install.root")
fileSeparator=WPSMigrationUtil.getFileSeparator()
scriptsPath=wpsRootPath+fileSeparator+"util"+fileSeparator+"adapterMigration"+fileSeparator
sys.path.append(scriptsPath)

import printHelper as PrintHelper
from java.lang import System

lineSeparator = System.getProperty("line.separator")
#mcfProperties = ['authDataAlias','authMechanismPreference','category','description','diagnoseConnectionUsage','jndiName','logMissingTransactionContext','manageCachedHandles','name','preTestConfig','providerType','xaRecoveryAuthAlias']
#asProperties = ['authenticationAlias','description','jndiName','name']
#raProperties = ['classpath']

#def listSearch(lst, target):
#        if(lst.count(target)<=0): return -1
#        return lst.index(target)
def wsadminToList(inStr):
        outList=[]
        if (len(inStr)>0 and inStr[0]=='[' and inStr[-1]==']'):
                tmpList = inStr[1:-1].split() #splits space-separated lists,
        else:
                tmpList = inStr.split("\n")   #splits for Windows or Linux
        for item in tmpList:
                item = item.rstrip();         #removes any Windows "\r"
                if (len(item)>0):
                        outList.append(item)
        return outList
#endDef

def wsadminToList1(inStr):
        outList=[]
        if (len(inStr)>0 and inStr[0]=='[' and inStr[-1]==']'):
                tmpList = inStr[1:-1].split(None, 1) #splits space-separated lists,
        else:
                tmpList = inStr.split("\n")   #splits for Windows or Linux
        for item in tmpList:
                item = item.rstrip();         #removes any Windows "\r"
                if (len(item)>0):
                        outList.append(item)
        return outList
#endDef

def stripPrefix_Suffix(inStr, fix):
	fixLen = len(fix)
	inStrLen = len(inStr)
	#print "inStr="+inStr + "  fix="+fix
	if (fixLen>0 and inStrLen>0 and inStr[0:fixLen]==fix and inStr[inStrLen-fixLen:inStrLen]==fix):
		str = inStr[fixLen:inStrLen-fixLen]
		#print "str="+str
		return str
	return inStr
#endDef

def getNodeType():
	nodeType = WPSMigrationUtil.getSystemProperty("bpm.upgrade.node.type")
	if (nodeType==""):
		nodeType = ""
	
	return nodeType
#end def getNodeType()
	
def getObjectArray(value):
	from java.lang import String
	objectArray = [];
	# @todo: do we have a space problem here?
	stringValue = String(value);
	if (stringValue.length() != 0):
		objectArray = value.split(lineSeparator);
	return objectArray;
#end Def getObjectArray(value)

def findReferencedAdapterOnNode(node, attribute, attrCheckValue):
	nodeRAID = ''
	try:
		ralistStr = AdminConfig.list("J2CResourceAdapter", node )
		raList = getObjectArray(ralistStr)

		for ra in raList:
			attrValue = AdminConfig.showAttribute(ra, attribute)
			if ( attrCheckValue == attrValue ):
				nodeRAID = ra
				break
	except:
		nodeRAID = ''
		
	return nodeRAID
#end def findReferencedAdapterOnNode(node)

def removeRAR(raID,raName,raDisplayName):
	AdminConfig.remove(raID)
	AdminConfig.save()
	#remove the adapter install folder
	#profileFolder = System.getProperty('user.install.root')
	#adapterFolder = profileFolder+fileSeparator+"installedConnectors"+fileSeparator+WPSMigrationUtil.getStandaloneAdapterFolder(raDisplayName)
	#WPSMigrationUtil.deleteFile(adapterFolder)
	
	PrintHelper.printInfo( "----Successfully remove resource adapter: "+raName +"!" )
#end def removeRAR

def installRAR(raName,raDisplayName, nodeName):
	rarpath = WPSMigrationUtil.getNewAdapterRARLoc(raDisplayName)
	try:
		AdminConfig.installResourceAdapter(rarpath, nodeName,'[-rar.name \"'+raName+'\" -rar.desc "WebSphere Adapter"]')
	except:
		PrintHelper.printInfo('failed to install RAR.'+raName+' root cause:')
		PrintHelper.printInfo(sys.exc_type)
		PrintHelper.printInfo(sys.exc_value)
	else:
		AdminConfig.save()
		PrintHelper.printInfo( "----Successfully installed resource adapter: "+raName +"!")
#end def installRAR

def updateClusterStandaloneRAR(cluster, clusterRA, raDisplayName):
	nodelist = AdminConfig.list("Node" )
	nodeArr = getObjectArray(nodelist)
	cell = AdminConfig.list('Cell').split(lineSeparator)[0]
	cellname = cell.split('(')[0]
	nodeRAID = ''
	
	for node in nodeArr:
		nodeRAID = ''
		nodeName = AdminConfig.showAttribute(node, 'name')
		id = "/Cell:"+cellname+"/Node:"+nodeName + "/J2CResourceAdapter:" + raDisplayName +"/"
		nodeRAID = AdminConfig.getid(id)
		
		if ( nodeRAID == ''):
			attribute = "classpath"
			attrValue = AdminConfig.showAttribute(clusterRA, attribute)
			nodeRAID = findReferencedAdapterOnNode(node, attribute, attrValue)
		
		if (nodeRAID != ''):
			newRARPath = WPSMigrationUtil.getNewAdapterRARLoc(raDisplayName)
			raNameStr = AdminConfig.show(nodeRAID, ["name"] )
			raNameList = wsadminToList1(raNameStr)
			raName = stripPrefix_Suffix(raNameList[1],"\"")

			PrintHelper.printInfo("---update cluster level standalone adapter on node " + nodeName + ": raName=" + raName)
			PrintHelper.printInfo("DisplayName=" + raDisplayName + ". newRARLoc=" + newRARPath)
			#PrintHelper.printInfo(nodeRAID)
			#AdminTask.updateRAR(nodeRAID, '[-rarPath '+newRARPath+']')
			#AdminConfig.save()
			removeRAR(nodeRAID,raName,raDisplayName)
			installRAR(raName,raDisplayName, nodeName)
#end def updateClusterStandaloneRAR