# BEGIN COPYRIGHT
# *************************************************************************
# Licensed Materials - Property of IBM 
# 5724-L01, 5655-N53, 5724-I82, 5655-R15
# (C) Copyright IBM Corporation 2007, 2011. All rights reserved. 
# US Government Users Restricted Rights - Use, duplication, or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
# *************************************************************************
# END COPYRIGHT

# import related classes
import sys;
from java.lang import *;
import java.io.File as File;
import re;
import shutil;
import os;
import os.path;

print "*************************************************************************************"
print "start: init"
print ""

fileSeparator = System.getProperty("file.separator");
configUtilsScript = System.getProperty("was.install.root") + fileSeparator + "util" + fileSeparator + "config" + fileSeparator + "admin" + fileSeparator + "configUtils.py"
print "load configuration utils from ", configUtilsScript
execfile(configUtilsScript);

print ""
print "end: init"

def getServiceMonitorServerProvider(deploymentTargetContext):
    print ""
    serviceMonitorServer = "";
    
    print "Getting service monitor server provider at ",  deploymentTargetContext;
    print ""    
    
    serviceMonitorServer = getResourceEnvironmentProvider(deploymentTargetContext, "com.ibm.bpm.servicemonitor.server");    
            
    print "The service monitor server provider is ", serviceMonitorServer;
    print ""   
    return serviceMonitorServer;
                     
#endDef

def getServiceMonitorAgentProvider(deploymentTargetContext):
    print ""
    serviceMonitorAgent = "";
    
    print "Getting service monitor agent provider at ",  deploymentTargetContext;
    print ""    
    
    serviceMonitorAgent = getResourceEnvironmentProvider(deploymentTargetContext, "com.ibm.bpm.servicemonitor.agent");    
            
    print "The service monitor agent provider is ", serviceMonitorAgent;
    print ""   
    return serviceMonitorAgent;
                     
#endDef


def getServiceMonitorServer(deploymentTargetContext, create):
    print ""
    print "Getting service monitor server at ",  deploymentTargetContext;
    print ""
    
    serviceMonitorServer = getCoreServerConfigObject(deploymentTargetContext, "ServiceMonitorServer", create, [['monitorDataSize', '5'], ['enableQueryLimit', 'true'], ['queryLimit', '50000'], ['monitorAllAgents', 'true']]);
    
    
    print "The service monitor server is ", serviceMonitorServer;
    print ""   
    return serviceMonitorServer;                         
#endDef

def getServiceMonitorAgent(deploymentTargetContext, create):
    print ""
    print "Getting service monitor agent at ",  deploymentTargetContext;
    print ""
    
    serviceMonitorAgent = getCoreServerConfigObject(deploymentTargetContext, "ServiceMonitorAgent", create, [['enableSwitchOffTimeout','true'], ['switchOffTimeout','120'], ['dataUpdateInterval','5'], ['dataBufferSize','512']]);
    
    
    print "The service monitor agent is ", serviceMonitorAgent;
    print ""   
    return serviceMonitorAgent;                         
#endDef


def migrateServerMonitorServer(deploymentTargetContext):
    print ""
    print "migrating service monitor server at ",  deploymentTargetContext;
    print ""
    
    try:
        serviceMonitorServer = getServiceMonitorServer(deploymentTargetContext, "True")
        serviceMonitorServerProvider = getServiceMonitorServerProvider(deploymentTargetContext);
        
        if (isEmptyString(serviceMonitorServer) == "False") and (isEmptyString(serviceMonitorServerProvider) == "False"):
            
            propertySet = AdminConfig.showAttribute(serviceMonitorServerProvider, "propertySet");
    
            if (propertySet):
                print "The value of propertySet is ", propertySet;
                resourceProperties = getObjectArray(AdminConfig.list("J2EEResourceProperty", propertySet));
                print ""                
                print "The value of resourceProperties is ", resourceProperties;                
                
                for resourceProperty in resourceProperties:
                    print ""
                    print "current property :", AdminConfig.show(resourceProperty);               
                    propertyName = AdminConfig.showAttribute(resourceProperty, "name");
                    if (propertyName == "monitorTargets"):                        
                        propertyValue = AdminConfig.showAttribute(resourceProperty, "value");
                        if (isEmptyString(propertyValue) == "False"):
                            AdminConfig.modify(serviceMonitorServer, [['monitorAllAgents', 'false']]);
                            monitorTargets = getArray(propertyValue, ",");
                            for monitorTarget in monitorTargets:
                                print "The value of monitorTarget is ", monitorTarget;
                                monitorTarget = "cells:" + System.getProperty("local.cell") + ":" + monitorTarget;
                                print "The value of monitorTarget with cell context is ", monitorTarget;
                                serviceMonitorAgentTarget = AdminConfig.create("ServiceMonitorAgentTarget", serviceMonitorServer, [['contextID', monitorTarget]]);
                                print ""            
                                print "adding service monitor agent target ", AdminConfig.show(serviceMonitorAgentTarget);                
                    elif (propertyName == "enable"):
                        propertyValue = AdminConfig.showAttribute(resourceProperty, "value");
                        if (isEmptyString(propertyValue) == "False"):
                            AdminConfig.modify(serviceMonitorServer, [['enable',propertyValue]]);
                    elif (propertyName == "monitorDataSize"):
                        propertyValue = AdminConfig.showAttribute(resourceProperty, "value");
                        if (isEmptyString(propertyValue) == "False"):
                            AdminConfig.modify(serviceMonitorServer, [['monitorDataSize',propertyValue]]);
                    elif (propertyName == "queryLimit"):
                        propertyValue = AdminConfig.showAttribute(resourceProperty, "value");
                        if (isEmptyString(propertyValue) == "False"):
                            AdminConfig.modify(serviceMonitorServer, [['queryLimit',propertyValue]]);
                            AdminConfig.modify(serviceMonitorServer, [['enableQueryLimit', "true"]]);
                            
            AdminConfig.remove(serviceMonitorServerProvider);
                
        print ""
        print "service monitor server:"            
        print AdminConfig.show(serviceMonitorServer);                
        print "migrated service monitor server at ",  deploymentTargetContext;
                
    except:
        print "Cannot migrate service monitor server configuration. The exception type is: ", sys.exc_type, ". The exception description is: ", sys.exc_value      
           
    print ""   
#endDef

def migrateServerMonitorAgent(deploymentTargetContext):
    print ""
    print "migrating service monitor agent at ",  deploymentTargetContext;
    print ""
    
    try:
        serviceMonitorAgent = getServiceMonitorAgent(deploymentTargetContext, "True")
        serviceMonitorAgentProvider = getServiceMonitorAgentProvider(deploymentTargetContext);
        
        if (isEmptyString(serviceMonitorAgent) == "False") and (isEmptyString(serviceMonitorAgentProvider) == "False"):
            
            propertySet = AdminConfig.showAttribute(serviceMonitorAgentProvider, "propertySet");
    
            if (propertySet):
                print "The value of propertySet is ", propertySet;
                resourceProperties = getObjectArray(AdminConfig.list("J2EEResourceProperty", propertySet));
                print ""                
                print "The value of resourceProperties is ", resourceProperties;                
                
                for resourceProperty in resourceProperties:
                    print ""
                    print "current property :", AdminConfig.show(resourceProperty);               
                    propertyName = AdminConfig.showAttribute(resourceProperty, "name");
                    if (propertyName == "enable"):
                        propertyValue = AdminConfig.showAttribute(resourceProperty, "value");
                        if (isEmptyString(propertyValue) == "False"):
                            AdminConfig.modify(serviceMonitorAgent, [['enable',propertyValue]]);
                    elif (propertyName == "monitorOffSwitchTimeout"):
                        propertyValue = AdminConfig.showAttribute(resourceProperty, "value");
                        if (isEmptyString(propertyValue) == "False"):
                            AdminConfig.modify(serviceMonitorAgent, [['switchOffTimeout',propertyValue]]);
                    elif (propertyName == "dataUpdateInterval"):
                        propertyValue = AdminConfig.showAttribute(resourceProperty, "value");
                        if (isEmptyString(propertyValue) == "False"):
                            AdminConfig.modify(serviceMonitorAgent, [['dataUpdateInterval',propertyValue]]);
                    elif (propertyName == "dataBufferSize"):
                        propertyValue = AdminConfig.showAttribute(resourceProperty, "value");
                        if (isEmptyString(propertyValue) == "False"):
                            AdminConfig.modify(serviceMonitorAgent, [['dataBufferSize',propertyValue]]);
                            
            AdminConfig.remove(serviceMonitorAgentProvider);
                
        print ""            
        print "service monitor agent:"
        print AdminConfig.show(serviceMonitorAgent);                
        print "migrated service monitor agent at ",  deploymentTargetContext;
                
    except:
        print "Cannot migrate service monitor agent configuration. The exception type is: ", sys.exc_type, ". The exception description is: ", sys.exc_value      
           
    print ""   
#endDef


print "*************************************************************************************"
print "start: service monitor configuration migration"
print ""
try:
    cellType = getCellType();
    
    if cellType == 'STANDALONE':
        print "Migrating the stand-alone profile"
                
        localServerContext =  getDeploymentTargetContext("use-local-server");
                
        migrateServerMonitorServer(localServerContext);        
        migrateServerMonitorAgent(localServerContext);
        
        AdminConfig.save();     
            
                                        
    elif cellType == 'DISTRIBUTED':
        print "Migrating the distributed (dmgr or customized) profile"
            # check whether the local node is a deployment manager Node
        isDMgrNode = isDMgrNode();
            
        if (isDMgrNode != "False"):
            migratedClusterName = System.getProperty("bpm.upgrade.cluster.name");
            print ""
            print "The value of migratedClusterName is ", migratedClusterName;
            
            if migratedClusterName and (isEmptyString(migratedClusterName) == "False"):
                migratedClusterContext = getDeploymentTargetContext("clusters:" + migratedClusterName);
                
                migrateServerMonitorServer(migratedClusterContext);        
                migrateServerMonitorAgent(migratedClusterContext);
                
                AdminConfig.save();                        
                                
        else:        
            print "Migrating the distributed custom profile"
            
            nodeID = AdminConfig.getid(getCellContext() + getNodeContext("use-local-server"));            
            print ""
            print "The value of nodeID is ", nodeID;

            servers = getObjectArray(AdminConfig.list("Server", nodeID));
            
            for server in servers:
                serverType = AdminConfig.showAttribute(server, "serverType");
                print ""
                print "The value of serverType is ", serverType
                
                if (serverType == "APPLICATION_SERVER"):
                    serverName = AdminConfig.showAttribute(server, "name");
                    print "The value of serverName is ", serverName
                    
                    clusterName = AdminConfig.showAttribute(server, "clusterName");
                    print "The value of clusterName is ", clusterName
                    
                    if (not (clusterName)) or (isEmptyString(clusterName) == "True"):
                        print "Migrating server ", serverName, " on Node ", System.getProperty("local.node");                       
                        
                        deploymentTargetContext = getDeploymentTargetContext("nodes:" + System.getProperty("local.node") + ":" + "servers:" + serverName);
                        
                        migrateServerMonitorServer(deploymentTargetContext);        
                        migrateServerMonitorAgent(deploymentTargetContext);
                        
                        AdminConfig.save();                    
                    else:
                        print "Skipping the migration for cluster members"             
            
    else:
        print "Unknown cell type"
except:
    print "Cannot migrate service monitor configuration. The exception type is: ", sys.exc_type, ". The exception description is: ", sys.exc_value      
                
            
print 
print ""
print "end: service monitor configuration migration"
print "*************************************************************************************"